#define	COBJMACROS
#include <windows.h>
#include <shlobj.h>
#include <process.h>
#include <stdlib.h>
#include <stdio.h>
#include "FileCopy.h"

// EBhEENX
#define	MYWNDCLSNAME		"MyWindowClass"

#define	RC_ERROR			0
#define	RC_NOERROR			1

HINSTANCE g_hInst;					// CX^XEnh

typedef struct{
	char src[MAX_PATH];
	char dsn[MAX_PATH];
} PARAMS;

unsigned __stdcall copyfile( void *params)
{
	int rc = RC_ERROR;
	if( params != NULL){
		HANDLE fhSrc, fhDsn;
		char buffer[10000];
		DWORD readNum, writeNum;
		PARAMS *pParams = (PARAMS *)params;
		
		// Rs[̃t@CJ
		fhSrc = CreateFile( pParams->src, GENERIC_READ, 0, NULL, OPEN_EXISTING,
								0, NULL);
		if( fhSrc == INVALID_HANDLE_VALUE)	return rc;
		
		// Rs[̃t@CJ
		fhDsn = CreateFile( pParams->dsn, GENERIC_WRITE, 0, NULL, OPEN_EXISTING,
								0, NULL);
		if( fhDsn == INVALID_HANDLE_VALUE){
			CloseHandle( fhSrc);
			return rc;
		}
		
		rc = RC_ERROR;
		while( ReadFile( fhSrc, buffer, sizeof(buffer), &readNum, NULL) ){
			if( readNum == 0){
				rc = RC_NOERROR;
				break;
			}
			
			if( !WriteFile( fhDsn, buffer, readNum, &writeNum, NULL) ){
				break;
			}
		}
		if( rc == RC_ERROR){
			MessageBox( 0, "̧ق̺߰ɴװ܂", "װ", MB_OK);
		}
		else{
			MessageBox( 0, "̧ق̺߰܂", "", MB_OK);
		}
		
		// t@C
		CloseHandle( fhSrc);
		CloseHandle( fhDsn);
		
		// p[^̃[EubN
		free( pParams);
	}
	else{
		MessageBox( 0, "װ", "װ", MB_OK);
	}
	return rc;
}

void FileCopy( HWND hWnd)
{
	OPENFILENAME ofn;
	BROWSEINFO bi;
	LPITEMIDLIST pidl;
	char src[MAX_PATH];
	char dsn[MAX_PATH];
	PARAMS *pParams;
	HANDLE hThread;
	
	// Rs[t@Cw肷_CAO\
	memset( &ofn, 0, sizeof(ofn) );
	ofn.lStructSize = sizeof(ofn);
	ofn.hwndOwner  = hWnd;
	ofn.hInstance = g_hInst;
	ofn.Flags = OFN_FILEMUSTEXIST;
	ofn.lpstrTitle = "̧߰قw肵Ă";
	ofn.lpstrFile = src;
	ofn.nMaxFile = sizeof(src);
	if( !GetOpenFileName( &ofn) )	return;
	
	// Rs[fBNgw肷_CAO\
	memset( &bi, 0, sizeof(bi) );
	bi.hwndOwner = hWnd;
	bi.pszDisplayName = dsn;
	bi.lpszTitle = "߰ިڸ؂w肵Ă";
	bi.ulFlags = BIF_RETURNFSANCESTORS | BIF_RETURNONLYFSDIRS;
	pidl = SHBrowseForFolder( &bi);
	if( pidl != NULL){
		HANDLE fhDsn;
		LPMALLOC pMalloc;
		unsigned thrdID;
		
		// ꂽʂpXɕϊ
		SHGetPathFromIDList( pidl, dsn);
		if( SHGetMalloc( &pMalloc) == NOERROR){
			IMalloc_Free( pMalloc, pidl);
		}
		
		// [gEfBNgłȂꍇɂ́CŌɁu\v
		// ĂȂ̂Œǉ
		if( dsn[3] != '\0')	strcat( dsn, "\\");
		
		// Rs[̃t@CǉāCRs[tpXɂ
		strcat( dsn, &src[ofn.nFileOffset]);
		
		// tpXŔrāCt@Cǂ`FbN
		if( stricmp( src, dsn) == 0){
			MessageBox( hWnd, "̧قɂͺ߰ł܂", "װ", MB_OK);
			return;
		}
		
		// Rs[t@CVK쐬[hŊJĂ݂āC
		// Õt@C邩ǂ`FbN
		fhDsn = CreateFile( dsn, GENERIC_WRITE, 0, NULL, CREATE_NEW,
								FILE_ATTRIBUTE_NORMAL, NULL);
		if( fhDsn == INVALID_HANDLE_VALUE){
			// łɂꍇɂ́C㏑̊mF
			if( MessageBox( hWnd, "̧ق߰ިڸ؂ɑ݂܂B\n"
								"㏑܂?", "mF", MB_YESNO)
					!= IDYES){
				return;		// ㏑Ȃ
			}
			
			// ߂ăRs[t@C쐬
			fhDsn = CreateFile( dsn, GENERIC_WRITE, 0, NULL,
									CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
		}
		
		// t@CU
		CloseHandle( fhDsn);
		
		// Xbh̃p[^쐬
		pParams = (PARAMS *)malloc( sizeof(PARAMS) );
		if( pParams == NULL){
			MessageBox( hWnd, "ذ܂", "װ", MB_OK);
			return;
		}
		strcpy( pParams->src, src);
		strcpy( pParams->dsn, dsn);
		
		hThread = (HANDLE)_beginthreadex( NULL, 0, copyfile, pParams, 0,
												&thrdID);
		if( hThread == 0){
			MessageBox( hWnd, "گނ쐬ł܂ł", "װ", MB_OK);
			return;
		}
		else{
			CloseHandle( hThread);
		}
	}
}

LRESULT CALLBACK WndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch( uMsg){
	case WM_COMMAND:
		switch( LOWORD(wParam) ){
		case IDM_COPY:
			FileCopy( hWnd);
			return 0;
			
		case IDM_EXIT:
			DestroyWindow( hWnd);
			return 0;
		}
		break;
	
	case WM_DESTROY:
		PostQuitMessage( 0);
		return 0;
	}
	
	// ȂbZ[W̓VXeɔC
	return DefWindowProc( hWnd, uMsg, wParam, lParam);
}

int WINAPI WinMain( HINSTANCE hInst, HINSTANCE hPrevInst,
					LPSTR lpCmdLine, int nCmdShow)
{
	WNDCLASS wndcls;
	HWND hWnd;
	MSG msg;
	
	g_hInst = hInst;
	
	// EBhEENX̓o^
	ZeroMemory( &wndcls, sizeof(wndcls) );
	wndcls.lpfnWndProc = WndProc;
	wndcls.hInstance = hInst;
	wndcls.hIcon = LoadIcon( 0, IDI_APPLICATION);
	wndcls.hCursor = LoadCursor( 0, IDC_ARROW);
	wndcls.hbrBackground = (HBRUSH)COLOR_BACKGROUND;
	wndcls.lpszMenuName = "MAIN_MENU";
	wndcls.lpszClassName = MYWNDCLSNAME;
	if( RegisterClass( &wndcls) == 0)	return -1;
	
	// CEEBhE̍쐬
	hWnd = CreateWindow( MYWNDCLSNAME, "Main Window",
					WS_OVERLAPPEDWINDOW,
					CW_USEDEFAULT, CW_USEDEFAULT,
					400, 200,
					0,
					0, hInst, NULL);
	if( hWnd == 0)	return -2;
	
	// ɂāCEBhȄ\Ԃw肷
	ShowWindow( hWnd, nCmdShow);
	UpdateWindow( hWnd);
	
	// bZ[WE[v
	while( GetMessage( &msg, 0, 0, 0) ){
		DispatchMessage( &msg);
	}
	
	// WM_QUITbZ[WwParamvȌIR[hɂ
	return msg.wParam;
}
