#include <windows.h>
#include <tchar.h>
#include "common.h"

HANDLE	g_hMutex = 0;
USERINFO *g_pUserInfo = NULL;

BOOL CALLBACK DlgProc( HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch( uMsg){
	case WM_INITDIALOG:
		return TRUE;
	
	case WM_COMMAND:
		switch( LOWORD( wParam) ){
		case IDCANCEL:
			// _CAȌI
			EndDialog( hDlg, FALSE);
			return TRUE;
		}
		break;
		
	case WM_UPDATEINFO:
		if( WaitForSingleObject( g_hMutex, 1000) == WAIT_OBJECT_0){
			SetDlgItemText( hDlg, IDC_NAME, g_pUserInfo->name);
			SetDlgItemText( hDlg, IDC_ADDR, g_pUserInfo->addr);
			SetDlgItemText( hDlg, IDC_TEL, g_pUserInfo->tel);
			ReleaseMutex( g_hMutex);
		}
		else{
			MessageBox( 0, _T("հްɱł܂"), _T("װ"), MB_OK);
		}
	}
	return FALSE;
}

int WINAPI WinMain( HINSTANCE hInst, HINSTANCE hPrev, LPSTR lpCL, int nCS)
{
	int rc = -1;
	g_hMutex = OpenMutex( MUTEX_ALL_ACCESS, FALSE, MUTEXNAME);
	if( g_hMutex != 0){
		HANDLE hMem = OpenFileMapping( FILE_MAP_READ, FALSE, SMEMNAME);
		if( hMem != 0){
			g_pUserInfo = (USERINFO *)MapViewOfFile( hMem, FILE_MAP_READ, 0, 0, sizeof(USERINFO) );
			if( g_pUserInfo != NULL){
				DialogBox( hInst, MAKEINTRESOURCE( IDD_DISPINFO), 0, (DLGPROC)DlgProc);
				rc = 0;
				UnmapViewOfFile( g_pUserInfo);
			}
			CloseHandle( hMem);
		}
		CloseHandle( g_hMutex);
	}
	if( rc != 0){
		MessageBox( 0, _T("հް񂪗pł܂"), _T("װ"), MB_OK);
	}
	return 0;
}
