#include <windows.h>
#include <tchar.h>
#include "common.h"

HANDLE	g_hMutex = 0;
USERINFO *g_pUserInfo = NULL;

BOOL CALLBACK DlgProc( HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch( uMsg){
	case WM_INITDIALOG:
		return TRUE;
	
	case WM_COMMAND:
		switch( LOWORD( wParam) ){
		case IDOK:
			// [U[̐ݒ
			if( WaitForSingleObject( g_hMutex, 5000) == WAIT_OBJECT_0){
				GetDlgItemText( hDlg, IDC_NAME, g_pUserInfo->name, 1024);
				GetDlgItemText( hDlg, IDC_ADDR, g_pUserInfo->addr, 1024);
				GetDlgItemText( hDlg, IDC_TEL, g_pUserInfo->tel, 1024);
				
				HWND hwndTgt = FindWindow( NULL, DISPINFO_TITLE);
				if( hwndTgt != 0){
					PostMessage( hwndTgt, WM_UPDATEINFO, 0, 0);
				}
				
				ReleaseMutex( g_hMutex);
			}
			else{
				MessageBox( 0, _T("հްXVł܂B΂炭ĂĎsĂB"), _T("װ"), MB_OK);
			}
			break;
			
		case IDCANCEL:
			// _CAȌI
			EndDialog( hDlg, FALSE);
			return TRUE;
		}
		break;
	}
	return FALSE;
}

int WINAPI WinMain( HINSTANCE hInst, HINSTANCE hPrev, LPSTR lpCL, int nCS)
{
	int rc = -1;
	g_hMutex = CreateMutex( NULL, TRUE, MUTEXNAME);
	if( g_hMutex != 0){
		HANDLE hMem = CreateFileMapping( INVALID_HANDLE_VALUE, NULL, PAGE_READWRITE, 0, sizeof(USERINFO), SMEMNAME);
		if( hMem != 0){
			g_pUserInfo = (USERINFO *)MapViewOfFile( hMem, FILE_MAP_ALL_ACCESS, 0, 0, sizeof(USERINFO) );
			if( g_pUserInfo != NULL){
				_tcscpy( g_pUserInfo->name, _T("ݒ") );
				_tcscpy( g_pUserInfo->addr, _T("ݒ") );
				_tcscpy( g_pUserInfo->tel, _T("ݒ") );
				ReleaseMutex( g_hMutex);
				
				DialogBox( hInst, MAKEINTRESOURCE( IDD_USERINFO), 0, (DLGPROC)DlgProc);
				rc = 0;
				UnmapViewOfFile( g_pUserInfo);
			}
			CloseHandle( hMem);
		}
		CloseHandle( g_hMutex);
	}
	if( rc != 0){
		MessageBox( 0, _T("հްݒł܂"), _T("װ"), MB_OK);
	}
	return 0;
}
