#include <windows.h>
#include <commdlg.h>
#include <tchar.h>
#include <stdio.h>
#include "sample.h"

#define	MYWNDCLASS		TEXT("MyWindowClass")
#define	WNDTITLE		TEXT("͂Ă")

HINSTANCE g_hInst = 0;
LOGFONT g_logfont;
TCHAR g_dispChar = TEXT('A');

LRESULT CALLBACK WndProc( HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch( uMsg){
	case WM_COMMAND:
		switch( LOWORD(wParam) ){
		case IDM_FONT:
		{
			// tHgݒ̏ꍇCftHg̃tHg擾
			if( g_logfont.lfFaceName[0] == TEXT('\0') ){
				HDC hdc = GetDC( hwnd);
				HFONT fnt = (HFONT)GetCurrentObject( hdc, OBJ_FONT);
				if( fnt != 0){
					GetObject( fnt, sizeof(g_logfont), &g_logfont);
#if 0
					TCHAR tmp[256];
					_stprintf( tmp, TEXT("%s"), g_logfont.lfFaceName);
					OutputDebugString( tmp);
#endif
					
				}
				ReleaseDC( hwnd, hdc);
			}
			
			// tHgI_CAO\
			CHOOSEFONT chfnt;
			memset( &chfnt, 0, sizeof(chfnt) );
			chfnt.lStructSize = sizeof(chfnt);
			chfnt.hwndOwner = hwnd;
			chfnt.Flags = CF_SCREENFONTS | CF_INITTOLOGFONTSTRUCT;
			chfnt.lpLogFont = &g_logfont;
			chfnt.nFontType = SCREEN_FONTTYPE;
			if( ChooseFont( &chfnt) != 0){
				InvalidateRect( hwnd, NULL, TRUE);
			}
			break;
		}
		
		case IDM_EXIT:
			DestroyWindow( hwnd);
			break;
			
		default:
			return DefWindowProc( hwnd, uMsg, wParam, lParam );
		}
		break;
		
	case WM_PAINT:
	{
		PAINTSTRUCT ps;
		HDC hdc = BeginPaint (hwnd, &ps);
		
		// R[h`
		TCHAR buf[10];
		_stprintf( buf, TEXT("0x%04x"), g_dispChar);
		TextOut( hdc, 0, 0, buf, _tcslen( buf) );
		
		// `ptHgđI
		HFONT fnt = CreateFontIndirect( &g_logfont);
		HFONT fntOrig = (HFONT)SelectObject( hdc, fnt);

		// `
		buf[0] = g_dispChar;
		buf[1] = TEXT('\0');
		TextOut( hdc, 0, 30, buf, _tcslen( buf) );
		
		SelectObject( hdc, fntOrig);
		DeleteObject( fnt);
		EndPaint( hwnd, &ps);
		break;
	}
	
	case WM_CHAR:
#if 0
	{
		TCHAR buf[256];
		_stprintf( buf, TEXT("%04x\n"), wParam);
		OutputDebugString( buf);
	}
#endif
		// R[hۑčĕ`悷
		g_dispChar = (TCHAR)wParam;
		InvalidateRect( hwnd, NULL, TRUE);
		break;
		
	case WM_DESTROY:
		PostQuitMessage( 0);
		break;
		
	default:
		return DefWindowProc( hwnd, uMsg, wParam, lParam);
	}
	return 0;
}

ATOM MyRegisterClass( void)
{
	WNDCLASS wc;
	wc.style			= CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc		= (WNDPROC)WndProc;
	wc.cbClsExtra		= 0;
	wc.cbWndExtra		= 0;
	wc.hInstance		= g_hInst;
	wc.hIcon			= 0;
	wc.hCursor			= LoadCursor( NULL, IDC_ARROW);
	wc.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wc.lpszMenuName		= (LPCTSTR)IDC_SAMPLE;
	wc.lpszClassName	= MYWNDCLASS;
	return RegisterClass( &wc);
}

HWND InitInstance( int nCmdShow)
{
	HWND hwnd = CreateWindow( MYWNDCLASS, WNDTITLE, WS_OVERLAPPEDWINDOW,
								CW_USEDEFAULT, CW_USEDEFAULT,
								300, 300,
								NULL, NULL, g_hInst, NULL);
	if( hwnd == 0)	return 0;
	
	ShowWindow( hwnd, nCmdShow);
	UpdateWindow( hwnd);
	return hwnd;
}

int APIENTRY WinMain( HINSTANCE hInst, HINSTANCE hPrevInst,
						LPSTR lpCmdLine, int nCmdShow)
{
	g_hInst = hInst;
	
	MyRegisterClass();
	if( InitInstance( nCmdShow ) == 0)	return 0;
	
	memset( &g_logfont, 0, sizeof(g_logfont) );
	g_logfont.lfCharSet = SHIFTJIS_CHARSET;
	
	MSG msg;
	while( GetMessage( &msg, NULL, 0, 0) ){
		TranslateMessage( &msg);
		DispatchMessage( &msg);
	}

	return msg.wParam;
}
