#include <windows.h>
#include <shlwapi.h>
#include <initguid.h>
#include <devguid.h>
#include <stdio.h>

#define	DRVNAME				"keyswap"
#define	CLASSKEY_PATH		"SYSTEM\\CurrentControlSet\\Control\\Class\\%s"
#define	DRVKEY_PATH			"SYSTEM\\CurrentControlSet\\Services\\%s"
#define	VAL_UPPERFILTERS	"UpperFilters"

bool ModifyUpperFilter( const char *guidOfClass, const char *drvName, bool append)
{
	if( guidOfClass == 0 || drvName == 0)	return false;
	
	bool rc = false;
	
	char keyName[MAX_PATH];
	sprintf( keyName, CLASSKEY_PATH, guidOfClass);
	
	HKEY hKey;
	if( RegOpenKeyEx( HKEY_LOCAL_MACHINE, keyName, 0, KEY_ALL_ACCESS, &hKey) == ERROR_SUCCESS){
		// ̏ʃtB^ׂ̃TCY߂
		DWORD dwType = 0;
		DWORD dwSize = 0;
		if( RegQueryValueEx( hKey, VAL_UPPERFILTERS, NULL, NULL, NULL, &dwSize) == ERROR_SUCCESS){
			dwSize += 64;	// CXg[hCõTCYZ
			char *pBuf = new char[dwSize];
			if( pBuf != NULL){
				// ̏ʃhCoׂ擾
				if( RegQueryValueEx( hKey, VAL_UPPERFILTERS, NULL, &dwType, (BYTE *)pBuf, &dwSize) == ERROR_SUCCESS){
					if( dwType == REG_MULTI_SZ){
						// CXg[hCoǉς݂ǂmF
						bool found = false;
						char *ptr = pBuf;
						while( !found && *ptr != '\0'){
							if( _stricmp( ptr, drvName) == 0){
								found = true;
							}
							else{
								ptr += strlen( ptr) + 1;
							}
						}
						
						if( !found){
							// CXg[hCoǉς݂łȂ
							if( append){
								// Ō'\0't
								ptr = pBuf + dwSize - 1;
								
								// hCo'\0't
								int len = strlen( drvName) + 1;
								strcpy( ptr, drvName);
								ptr += len;
								*ptr = '\0';
								
								dwSize += len;
								
								rc = RegSetValueEx( hKey, VAL_UPPERFILTERS, 0, dwType, (BYTE *)pBuf, dwSize) == ERROR_SUCCESS;
							}
							else{
								rc = true;
							}
						}
						else{
							// CXg[hCoǉς
							if( append){
								rc = true;
							}
							else{
								// ̎_ptr͍폜hCowĂ͂
								int len = strlen( ptr) + 1;
								dwSize -= len;
								
								// ɂhCoOɂ炵ăRs[
								const char *ptr2 = ptr + len;
								while( *ptr2 != '\0'){
									len = strlen( ptr2) + 1;
									strcpy( ptr, ptr2);
									ptr += len;
									ptr2 += len;
								}
								*ptr = '\0';
								
								rc = RegSetValueEx( hKey, VAL_UPPERFILTERS, 0, dwType, (BYTE *)pBuf, dwSize) == ERROR_SUCCESS;
							}
						}
					}
				}
				delete []pBuf;
			}
		}
		RegCloseKey( hKey);
	}
	return rc;
}

bool ConfigDrvKey( const char *drvName, bool append)
{
	if( drvName == 0)	return false;
	
	bool rc = false;
	char keyName[MAX_PATH];
	sprintf( keyName, DRVKEY_PATH, drvName);
	
	HKEY hKey;
	if( append){
		if( RegCreateKeyEx( HKEY_LOCAL_MACHINE, keyName, 0, "", 0, KEY_WRITE, NULL, &hKey, NULL)
				== ERROR_SUCCESS){
			DWORD dwData;
			
			dwData = 1;
			rc = RegSetValueEx( hKey, "ErrorControl", 0, REG_DWORD, (BYTE *)&dwData, sizeof(dwData) ) == ERROR_SUCCESS;
			dwData = 3;
			rc = rc && RegSetValueEx( hKey, "Start", 0, REG_DWORD, (BYTE *)&dwData, sizeof(dwData) ) == ERROR_SUCCESS;
			dwData = 1;
			rc = rc && RegSetValueEx( hKey, "Type", 0, REG_DWORD, (BYTE *)&dwData, sizeof(dwData) ) == ERROR_SUCCESS;
			
			RegCloseKey( hKey);
		}
	}
	else{
		if( RegOpenKeyEx( HKEY_LOCAL_MACHINE, keyName, 0, KEY_WRITE, &hKey) == ERROR_SUCCESS){
			RegCloseKey( hKey);
			// TuL[ċAIɍ폜
			rc = SHDeleteKey( HKEY_LOCAL_MACHINE, keyName) == ERROR_SUCCESS;
		}
		else{
			rc = true;
		}
	}
	return rc;
}

int __cdecl main( int argc, char **argv)
{
	if( argc != 2
			|| ( strcmp( argv[1], "-i") != 0 && strcmp( argv[1], "-u") != 0) ){
		fprintf( stderr,
					"\"install -i\" to install or "
					"\"install -u\" to uninstall.\n");
		return -1;
	}
	
	// GUID\쐬
	char guidstr[39];
	sprintf( guidstr, "{%08lX-%04X-%04X-%02X%02X-%02X%02X%02X%02X%02X%02X}",
				GUID_DEVCLASS_KEYBOARD.Data1,
				GUID_DEVCLASS_KEYBOARD.Data2,
				GUID_DEVCLASS_KEYBOARD.Data3,
				GUID_DEVCLASS_KEYBOARD.Data4[0],
				GUID_DEVCLASS_KEYBOARD.Data4[1],
				GUID_DEVCLASS_KEYBOARD.Data4[2],
				GUID_DEVCLASS_KEYBOARD.Data4[3],
				GUID_DEVCLASS_KEYBOARD.Data4[4],
				GUID_DEVCLASS_KEYBOARD.Data4[5],
				GUID_DEVCLASS_KEYBOARD.Data4[6],
				GUID_DEVCLASS_KEYBOARD.Data4[7]);
	
	bool rc = false;
	bool install = strcmp( argv[1], "-i") == 0;
	
	// CXg[̓hCoEt@CVXeEfBNgɃRs[
	// ACXg[͉Ȃit@C̍폜Ȃj
	if( install){
		char sysdir[MAX_PATH];
		if( GetSystemDirectory( sysdir, sizeof(sysdir) ) != 0){
			char drvFile[MAX_PATH];
			sprintf( drvFile, "%s.sys", DRVNAME);
			
			// VXeEfBNg̓[gł͂蓾Ȃ̂
			// ɃpX؂蕶'\'tĂ悢
			strcat( sysdir, "\\drivers\\");
			strcat( sysdir, drvFile);
			rc = CopyFile( drvFile, sysdir, FALSE) != FALSE;
		}
		
		if( !rc){
			fprintf( stderr, "Cannot copy a driver file to the system directory.\n"
							 "Installation failed.\n");
			return -1;
		}
	}
	
	// WXgύX
	if( ModifyUpperFilter( guidstr, DRVNAME, install) ){
		if( ConfigDrvKey( DRVNAME, install) ){
			fprintf( stderr, "%s of keyswap is successfully completed.\n", install? "Installation": "Uninstallation");
			rc = true;
		}
	}
	
	if( !rc)	fprintf( stderr, "Unexpected error happened. Please check the registry with regedit.\n");
	
	return 0;
}
